"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var swagger_jsdoc_1 = __importDefault(require("swagger-jsdoc"));
var lodash_1 = require("lodash");
exports.blueprintActions = ['findone', 'find', 'create', 'update', 'destroy', 'populate', 'add', 'remove', 'replace'];
exports.attributeValidations = [
    'isAfter',
    'isBefore',
    'isBoolean',
    'isCreditCard',
    'isEmail',
    'isHexColor',
    'isIn',
    'isInteger',
    'isIP',
    'isNotEmptyString',
    'isNotIn',
    'isNumber',
    'isString',
    'isURL',
    'isUUID',
    'max',
    'min',
    'maxLength',
    'minLength',
    'regex',
    'custom',
];
exports.loadSwaggerDocComments = function (filePath) {
    return new Promise(function (resolve, reject) {
        try {
            var opts = {
                definition: {
                    openapi: '3.0.0',
                    info: { title: 'dummy', version: '0.0.0' },
                },
                apis: [filePath],
            };
            var specification = swagger_jsdoc_1.default(opts);
            resolve(specification);
        }
        catch (err) {
            reject(err);
        }
    });
};
exports.getUniqueTagsFromPath = function (paths) {
    var referencedTags = new Set();
    for (var path in paths) {
        var pathDefinition = paths[path];
        for (var verb in pathDefinition) {
            var verbDefinition = pathDefinition[verb];
            if (verbDefinition.tags) {
                verbDefinition.tags.forEach(function (tag) { return referencedTags.add(tag); });
            }
        }
    }
    return referencedTags;
};
exports.resolveRef = function (specification, obj) {
    var path = obj.$ref;
    if (typeof (path) === 'string' && path.startsWith('#/')) {
        var pathElements = path.substring(2).split('/');
        return lodash_1.get(specification, pathElements);
    }
    return obj;
};
